import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { DescribeImageAttributeRequest, ImageAttribute } from "../models/models_3";
import { deserializeAws_ec2DescribeImageAttributeCommand, serializeAws_ec2DescribeImageAttributeCommand, } from "../protocols/Aws_ec2";
var DescribeImageAttributeCommand = (function (_super) {
    __extends(DescribeImageAttributeCommand, _super);
    function DescribeImageAttributeCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    DescribeImageAttributeCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "EC2Client";
        var commandName = "DescribeImageAttributeCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: DescribeImageAttributeRequest.filterSensitiveLog,
            outputFilterSensitiveLog: ImageAttribute.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    DescribeImageAttributeCommand.prototype.serialize = function (input, context) {
        return serializeAws_ec2DescribeImageAttributeCommand(input, context);
    };
    DescribeImageAttributeCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_ec2DescribeImageAttributeCommand(output, context);
    };
    return DescribeImageAttributeCommand;
}($Command));
export { DescribeImageAttributeCommand };
