import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { DescribeReplaceRootVolumeTasksRequest, DescribeReplaceRootVolumeTasksResult } from "../models/models_3";
import { deserializeAws_ec2DescribeReplaceRootVolumeTasksCommand, serializeAws_ec2DescribeReplaceRootVolumeTasksCommand, } from "../protocols/Aws_ec2";
var DescribeReplaceRootVolumeTasksCommand = (function (_super) {
    __extends(DescribeReplaceRootVolumeTasksCommand, _super);
    function DescribeReplaceRootVolumeTasksCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    DescribeReplaceRootVolumeTasksCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "EC2Client";
        var commandName = "DescribeReplaceRootVolumeTasksCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: DescribeReplaceRootVolumeTasksRequest.filterSensitiveLog,
            outputFilterSensitiveLog: DescribeReplaceRootVolumeTasksResult.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    DescribeReplaceRootVolumeTasksCommand.prototype.serialize = function (input, context) {
        return serializeAws_ec2DescribeReplaceRootVolumeTasksCommand(input, context);
    };
    DescribeReplaceRootVolumeTasksCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_ec2DescribeReplaceRootVolumeTasksCommand(output, context);
    };
    return DescribeReplaceRootVolumeTasksCommand;
}($Command));
export { DescribeReplaceRootVolumeTasksCommand };
