import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { ModifyReservedInstancesRequest, ModifyReservedInstancesResult } from "../models/models_5";
import { deserializeAws_ec2ModifyReservedInstancesCommand, serializeAws_ec2ModifyReservedInstancesCommand, } from "../protocols/Aws_ec2";
var ModifyReservedInstancesCommand = (function (_super) {
    __extends(ModifyReservedInstancesCommand, _super);
    function ModifyReservedInstancesCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    ModifyReservedInstancesCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "EC2Client";
        var commandName = "ModifyReservedInstancesCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: ModifyReservedInstancesRequest.filterSensitiveLog,
            outputFilterSensitiveLog: ModifyReservedInstancesResult.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    ModifyReservedInstancesCommand.prototype.serialize = function (input, context) {
        return serializeAws_ec2ModifyReservedInstancesCommand(input, context);
    };
    ModifyReservedInstancesCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_ec2ModifyReservedInstancesCommand(output, context);
    };
    return ModifyReservedInstancesCommand;
}($Command));
export { ModifyReservedInstancesCommand };
