import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { WithdrawByoipCidrRequest, WithdrawByoipCidrResult } from "../models/models_6";
import { deserializeAws_ec2WithdrawByoipCidrCommand, serializeAws_ec2WithdrawByoipCidrCommand, } from "../protocols/Aws_ec2";
var WithdrawByoipCidrCommand = (function (_super) {
    __extends(WithdrawByoipCidrCommand, _super);
    function WithdrawByoipCidrCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    WithdrawByoipCidrCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "EC2Client";
        var commandName = "WithdrawByoipCidrCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: WithdrawByoipCidrRequest.filterSensitiveLog,
            outputFilterSensitiveLog: WithdrawByoipCidrResult.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    WithdrawByoipCidrCommand.prototype.serialize = function (input, context) {
        return serializeAws_ec2WithdrawByoipCidrCommand(input, context);
    };
    WithdrawByoipCidrCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_ec2WithdrawByoipCidrCommand(output, context);
    };
    return WithdrawByoipCidrCommand;
}($Command));
export { WithdrawByoipCidrCommand };
